//+------------------------------------------------------------------+
//|                                                    vert_line.mq4 |
//|                                            Aleksandr Pak, Almaty |
//|                                                   ekr-ap@mail.ru |
//|   GTerminal           |
//|                                                 |
//+------------------------------------------------------------------+
#property copyright "AP, Almaty"
#property link      "ekr-ap@mail.ru"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

extern bool Teg_Pause = TRUE;  //   ,     ,   ,    
int Pause=0;
double last_pause;
string Pause_name;
int t_first=0; 

datetime TimeVertLine;

int init()
  {
if(!IsTesting())
     {
         if(Teg_Pause)
         {
         if(ObjectFind("PAUSE")<0)
         {ObjectCreate("PAUSE", OBJ_VLINE, 0,iTime(Symbol(),0,0)+12*60*Period(),0);
         ObjectSet("PAUSE",OBJPROP_WIDTH,1);
         ObjectSet("PAUSE",OBJPROP_COLOR,Red);             
         }
         else ObjectSet("PAUSE",OBJPROP_TIME1,iTime(Symbol(),0,0)+12*60*Period());
         }
    }          
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   ObjectDelete("PAUSE");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
 
 
 //#1  
 if(!search_name_pause())
      {
      //      ,  
      }
      else
      {
      
      //       TimeVertLine    
      }
 //#2 
 
 search_name_pause(); //   =TimeVertLine
 //  
 
   
   
   return(0);
  }
//+------------------------------------------------------------------+

bool search_name_pause()
{double p,p2,t,t2,y; int error,i; string n;
         if(IsTesting()) return(FALSE);
         
         if(!Teg_Pause) return (FALSE);
         i=search_name_obj("paus");
         if (i>=0)
         {
            p=   ObjectGet(Pause_name,OBJPROP_TIME1);
            TimeVertLine=p; //  
            p2=iTime(NULL,0,0); 
     
            
            if(p-p2<0) 
               { 
               
               if(last_pause==p&&Pause==0) //           
               {
               //         
                y=p2+12*60*Period(); //=    12     
                        for(i=0;i<10;i++)
                        {
                        ObjectSet(Pause_name,OBJPROP_TIME1,y);
                        WindowRedraw();
                        if(GetLastError()==0) break;
                        Sleep(100);
                        }
                       
                        last_pause=   y;
                        return(FALSE);
               }
               //   
                else
                {
                  //   -   , .
                  Pause=1;
                  ObjectSet(Pause_name,OBJPROP_WIDTH,4);
                  WindowRedraw();
                  last_pause=p;
                  
                  
                  
               return(TRUE); 
               }
               } else  
                        {                        
                        ObjectSet(Pause_name,OBJPROP_WIDTH,1);
                        if(t_first==1)
                              {
                              ObjectSet(Pause_name,OBJPROP_TIME1,ObjectGet(Pause_name,OBJPROP_TIME1)+Period()*60);
                              }
                        Pause=0;
                        WindowRedraw();
                        last_pause=ObjectGet(Pause_name,OBJPROP_TIME1); 
                        return(FALSE);
                        }
         }
}


//////
int search_name_obj(string c) 
{int i,k; string s;
   k=ObjectsTotal(); 
   for(i=k-1;i>=0;i--)  
   {  
      s=lowercaps(ObjectName(i));
    if (StringFind(s,c,0)>=0){ Pause_name=ObjectName(i); return(i);} 
   }
return (-1);
}
////////////

string lowercaps(string s)
{int i,k,c; string r=""; k=StringLen(s); for(i=0;i<k;i++){c=StringGetChar(s,i); if(c<91&&c>64) c+=32;r=r+CharToStr(c);}
 return (r);
}
////